/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

#ifndef INCLUDE_MY_COLOR_SELECTION_HH
#define INCLUDE_MY_COLOR_SELECTION_HH

/* $Id: my_color_selection.hh,v 1.1 2002/09/09 18:30:25 itz Exp $ */

#include <gtk--/colorselection.h>
#include <string>

namespace Gtk {
  class Dialog;
  class Label;
}

class my_clist;

class my_color_selection : public Gtk::ColorSelection {
public:
  my_color_selection();
  void set_color_and_notify(const gdouble* color);

private:
  void quit_handler();
  void grab_handler();
  void show_handler();
  void list_select_handler();
  void end_modal_handler();
  void search_handler();
  void end_search_handler();
  void select_row_handler(gint row, gint column, GdkEvent* p_ev);
  gint enter_key_handler(GdkEventKey* p_key);

  Gtk::Dialog* modal;
  SigC::Connection end_modal_handler_id;
  my_clist* p_clist;
  Gtk::Label* p_echo;

  string search_string;
  int find_result;
protected:
  virtual void color_changed_impl();
};

#endif // INCLUDE_MY_COLOR_SELECTION_HH
